/*******************

Written by Frank Rimlinger, May 1993
*******************/

#include "crossTrainer.h"
#include "FpTreeInitInfo.h"
#include <stdio.h>
#include "FGLvar.h"
#include "FpTree.h"

FpTreeInitInfo::FpTreeInitInfo(void){

// NAME
	sprintf((char *)errorStr,"pTree"); // designation of GLvar for error handler
	CtoPstr((char *)errorStr);				  // use Pascal version
// WALKS
	IDactiveMax=3;				// we need a slot for the pass number, 
								// the walk ID, and for clean up

// PACKET SIZES	
	rNoEntries=5;				// real link of a real vertex 
	iNoEntries=10;				// ideal link of an ideal vertex 			
	lutNoEntries=5;			// ideal vertex look-up table				
	ChildNoEntries=10;			// child vertices generated by FGLwalkNode
	
// DATA
	useD=TRUE;
	DtypeSize=sizeof(FpTree::D);
	useiD=FALSE;
	// iDtypeSize=sizeof(FpTree::iD);

	
// RECYCLING
	recycleBlockSize=1064;
	recycleReal=TRUE;
	recycleIdeal=TRUE;
	
// BACKYARDS
	rBackYardSize=0;
	irBackYardSize=0;
	iBackYardSize=0;
	lutBackYardSize=0;
	rvBackYardSize=0;
	ivBackYardSize=0;
}
